Home | History | Annotate | Download | only in move
      1 #!/bin/bash
      2 
      3 #
      4 # Copyright (c) International Business Machines  Corp., 2005
      5 # Author: Avantika Mathur (mathurav (at] us.ibm.com)
      6 #
      7 # This library is free software; you can redistribute it and/or
      8 # modify it under the terms of the GNU Lesser General Public
      9 # License as published by the Free Software Foundation; either
     10 # version 2.1 of the License, or (at your option) any later version.
     11 #
     12 # This library is distributed in the hope that it will be useful,
     13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
     14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     15 # Lesser General Public License for more details.
     16 #
     17 # You should have received a copy of the GNU Lesser General Public
     18 # License along with this library; if not, write to the Free Software
     19 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
     20 #
     21 
     22 SETS_DEFAULTS="${TCID=test05} ${TST_COUNT=1} ${TST_TOTAL=1}"
     23 declare -r TCID
     24 declare -r TST_COUNT
     25 declare -r TST_TOTAL
     26 export TCID TST_COUNT TST_TOTAL
     27 
     28 tst_resm TINFO "***************TEST05***************"
     29 tst_resm TINFO "move: private subtree to shared parent."
     30 tst_resm TINFO "************************************"
     31 
     32 . "${FS_BIND_ROOT}/bin/setup" || (tst_resm TWARN "Setup of move/test05 failed" && tst_exit)
     33 export result=0
     34 
     35 
     36 
     37 trap 'ERR=$? ; ERR_MSG="caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"; break' ERR
     38 
     39 while /bin/true ; do
     40 	# This loop is for error recovery purposes only
     41 
     42 
     43 	"${FS_BIND_ROOT}/bin/makedir" priv dir
     44 	"${FS_BIND_ROOT}/bin/makedir" share parent2
     45 	"${FS_BIND_ROOT}/bin/makedir" share share2
     46 	"${FS_BIND_ROOT}/bin/makedir" share share1
     47 
     48 	mount --bind parent2 share2
     49 	mkdir dir/grandchild
     50 	mount --bind dir share1
     51 	mkdir parent2/child2
     52 	mount --move dir parent2/child2
     53 
     54 	mount --bind "$disk1" parent2/child2/grandchild
     55 	check parent2/child2/grandchild share2/child2/grandchild
     56 	check -n dir/grandchild parent2/child2/grandchild
     57 	check -n share1/grandchild parent2/child2/grandchild
     58 
     59 	mount --bind "$disk2" share2/child2/grandchild/a
     60 
     61 	check parent2/child2/grandchild/a share2/child2/grandchild/a
     62 
     63 	break
     64 done
     65 trap 'ERR=$? ; tst_resm TWARN "move/test05: caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"' ERR
     66 if [ -n "${ERR_MSG}" ]; then
     67 	tst_resm TWARN "move/test05: ${ERR_MSG}"
     68 	ERR_MSG=""
     69 	result=$ERR
     70 fi
     71 trap '' ERR
     72 {
     73 	umount parent2/child2/grandchild/a
     74 	umount parent2/child2/grandchild
     75 	umount parent2/child2 # if move succeeded
     76 	umount dir # if move failed
     77 	umount share1
     78 	umount share2
     79 	umount share1
     80 	umount share2
     81 	umount parent2
     82 
     83 	rm -rf dir parent* share*
     84 	cleanup
     85 } >& /dev/null
     86 if [ $result -ne 0 ]
     87 then
     88 	tst_resm TFAIL "move/test05: FAILED: move: private subtree to shared parent."
     89 	exit 1
     90 else
     91 	tst_resm TPASS "move/test05: PASSED"
     92 	exit 0
     93 fi
     94 tst_exit
     95